require "MercadoPagoLocal/version"

module MercadoPagoLocal
	require 'mercadopago.rb'
	class NullOrInvalidAttribute < StandardError; end

	autoload :User, "MercadoPago/user"
	autoload :Payment, "MercadoPago/payment"
	autoload :WebHook, "MercadoPago/webhook"
	autoload :ResponseHandler, "MercadoPago/response_handler"
	autoload :Card, "MercadoPago/card"
	autoload :Customer, "MercadoPago/customer"
	autoload :Preapproval, "MercadoPago/preapproval"
	autoload :Plan, "MercadoPago/plan"
	autoload :Suscription, "MercadoPago/suscription"
	autoload :Invoice, "MercadoPago/invoice"
	autoload :DataBaseConfig, "MercadoPago/data_base_config"

	class << self
        mattr_accessor :business_name, :mail_from, :user_class_name, :payment_class_name, :plan_class_name, :suscription_class_name, :invoice_class_name,
        				:plan_class, :suscription_class, :invoice_class, :user_class, :payment_class
    end

    def self.setup(&block)
        yield self
        set_classes
    end

    def self.set_classes
    	MercadoPagoLocal.plan_class ||= Class.new(ActiveRecord::Base) do
    		self.primary_key = "plan_id"

    		def self.suscriptions(plan_id)
    			MercadoPagoLocal.suscription_class.where(plan_id: plan_id)
    		end

		  	def self.name
		   		MercadoPagoLocal.plan_class_name
		  	end
		end

		MercadoPagoLocal.suscription_class ||= Class.new(ActiveRecord::Base) do
			self.primary_key = "suscription_id"

		  	def self.name
		    	MercadoPagoLocal.suscription_class_name
		  	end

		  	def self.user(payer_email)
		  		MercadoPagoLocal.user_class.find_by_email(payer_email)
		  	end

		  	def self.invoices(suscription_id)
		  		MercadoPagoLocal.invoice_class.where(suscription_id: suscription_id)
		  	end
		end

		MercadoPagoLocal.invoice_class ||= Class.new(ActiveRecord::Base) do
			self.primary_key = "invoice_id"

			def self.suscription(suscription_id)
				MercadoPagoLocal.suscription_class.find(suscription_id)
			end

		  	def self.name
		    	MercadoPagoLocal.invoice_class_name
		  	end
		end

		MercadoPagoLocal.user_class ||= Class.new(ActiveRecord::Base) do
		  	def self.name
		    	MercadoPagoLocal.user_class_name
		  	end
		end

		MercadoPagoLocal.payment_class ||= Class.new(ActiveRecord::Base) do
		  	def self.name
		    	MercadoPagoLocal.payment_class_name
		  	end
		end
    end
end

